/** 
 *  Hyper Operating System  Application Framework
 *
 * @file  stringformat.h
 * @brief %jp{tH[}bgCu}
 *
 * %jp{_Ȃǂ̋@\yʔ printf 쐬ڎw}
 *
 * Copyright (C) 2008 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#ifndef __HOS__stringformat_h__
#define __HOS__stringformat_h__


#include <stdarg.h>


#ifdef __cplusplus
extern "C" {
#endif

int StringFormat_FormatString(char *pszBuf, int iBufSize, const char *pszFormat, ...);
int StringFormat_FormatStringV(char *pszBuf, int iBufSize, const char *pszFormat, va_list argptr);

int StringFormat_Format(int (*pfncPut)(int c, void *Param), void *Param, const char *pszFormat, ...);										/* to */	
int StringFormat_FormatV(int (*pfncPut)(int c, void *Param), void *Param, const char *pszFormat, va_list argptr);							/* to(Xgn) */

int StringFormat_Nibble(int (*pfncPut)(int c, void *Param), void *Param, unsigned char n);													/* 4bit16io */
int StringFormat_Hexadecimal(int (*pfncPut)(int c, void *Param), void *Param, unsigned long ulNum, int iWidth, int iPadChar, int iFlag);	/* 16io */
int StringFormat_Decimal(int (*pfncPut)(int c, void *Param), void *Param, long lNum, int iSigned, int iWidth, int iPadChar, int iFlag);		/* 10io */
int StringFormat_String(int (*pfncPut)(int c, void *Param), void *Param, const char *pszStr, int iWidth, int iFlag);						/* o */

#ifdef __cplusplus
}
#endif


#endif	/* __HOS__stringformat_h__ */


/* end of file */
