/** 
 *  Hyper Operating System  Application Framework
 *
 * @file  automemheap_free.c
 * @brief %jp{ŒTCYq[vNX}%en{fixed size memory heap class}
 *
 * Copyright (C) 2006-2008 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include <stdio.h>
#include "automemheap_local.h"


/** fXgN^ */
void AutoMemHeap_Destructor(C_AUTOMEMHEAP *self)							
{
	T_AUTOMEMHEAP_FIX	*pFixHeap;
	T_AUTOMEMHEAP_FIX	*pFixHeapNext;
	T_AUTOMEMHEAP_VAL	*pValHeap;
	T_AUTOMEMHEAP_VAL	*pValHeapNext;
	T_AUTOMEMHEAP_MEM	*pMemHeap;
	T_AUTOMEMHEAP_MEM	*pMemHeapNext;
	
	
	/* Œ蒷q[vJ */
	for ( pFixHeap = self->pFixList; pFixHeap != NULL; pFixHeap = pFixHeapNext )
	{
		pFixHeapNext = pFixHeap->pNext;
		MemHeap_Free(self->pMemHeap, pFixHeap);
	}
	
	/* ϒq[vɖT */
	for ( pValHeap = self->pValList; pValHeap != NULL; pValHeap = pValHeapNext )
	{
		pValHeapNext = pValHeap->pNext;
		MemHeap_Free(self->pMemHeap, pValHeap);
	}
	
	/* q[vɊJ */
	for ( pMemHeap = self->pMemList; pMemHeap != NULL; pMemHeap = pMemHeapNext )
	{
		pMemHeapNext = pMemHeap->pNext;
		MemHeap_Free(self->pMemHeap, pMemHeap);
	}
}


/* end of file */
