/** 
 *  Hyper Operating System  Application Framework
 *
 * @file  memheap.h
 * @brief %jp{q[vNX(ۃNX)}%en{memory heap class(abstract class)}
 *
 * Copyright (C) 2006-2008 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */



#ifndef __HOS__memheap_h__
#define __HOS__memheap_h__


#include "system/type/type.h"



/** %jp{MemHeapNX z֐e[u}%en{MemHeap class virtual function table} */
typedef struct t_memheap_methods
{
	void	*(*pfncAlloc)(void *pMemHeap, MEMSIZE Size);					/**< ̊蓖 */
	void	*(*pfncReAlloc)(void *pMemHeap, void *pMem, MEMSIZE Size);		/**< ̍Ċ蓖 */
	void	(*pfncFree)(void *pMemHeap, void *pMem);						/**< ̊J */
	MEMSIZE	(*pfncGetSize)(void *pMemHeap, void *pMem);						/**< ̃TCY擾 */
	MEMSIZE	(*pfncGetAlign)(void *pMemHeap);								/**< ACg̎擾 */
	MEMSIZE	(*pfncAlignSize)(void *pMemHeap, MEMSIZE Size);					/**< TCYACgPʂɊg */
	int		(*pfncIsMember)(void *pMemHeap, void *pMem);					/**< q[vɑĂ邩`FbN */
} T_MEMHEAP_METHODS;


/** %jp{MemHeapNX}%en{MemHeap class} */
typedef struct c_memheap
{
	const T_MEMHEAP_METHODS		*pMethods;
} C_MEMHEAP;



#ifdef __cplusplus
extern "C" {
#endif

#define MemHeap_Alloc(self, Size)				((self)->pMethods->pfncAlloc((self), (Size)))
#define MemHeap_ReAlloc(self, pMem, Size)		((self)->pMethods->pfncReAlloc((self), (pMem), (Size)))
#define MemHeap_Free(self, pMem)				((self)->pMethods->pfncFree((self), (pMem)))
#define MemHeap_GetSize(self, pMem)				((self)->pMethods->pfncGetSize((self), (pMem)))
#define MemHeap_GetAlign(self)					((self)->pMethods->pfncGetAlign((self)))
#define MemHeap_AlignSize(self, Size)			((self)->pMethods->pfncAlignSize((self), (Size)))
#define MemHeap_IsMember(self, pMem)			((self)->pMethods->pfncIsMember((self), (pMem)))

#ifdef __cplusplus
}
#endif



#endif	/* __HOS__memheap_h__ */


/* end of file */
