/**
 *  Hyper Operating System V4 Advance
 *
 * @file  mtxobj.h
 * @brief %jp{~[ebNXIWFNg̃wb_t@C}%en{Mutex object heder file}
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#ifndef _KERNEL__object__mtxobj_h__
#define _KERNEL__object__mtxobj_h__



/* ------------------------------------------ */
/*  Primitive type definition                 */
/* ------------------------------------------ */


/* %jp{~[ebNX^XNnhp̌^} */
typedef _KERNEL_T_TSKHDL				_KERNEL_MTX_T_TSKHDL;			/**< %jp{~[ebNX^XNnhZ삷Ƃ̌^} */
typedef _KERNEL_T_TSKHDL				_KERNEL_MTXCB_T_TSKHDL;			/**< %jp{~[ebNX^XNnhMTXCBɊi[Ƃ̌^} */
#define _KERNEL_MTXCB_TBITDEF_TSKHDL

/* %jp{~[ebNXnhp̌^} */
typedef _KERNEL_T_MTXHDL				_KERNEL_MTX_T_MTXHDL;			/**< %jp{~[ebNX^XNnhZ삷Ƃ̌^} */
typedef _KERNEL_T_MTXHDL				_KERNEL_MTXCB_T_MTXHDL;			/**< %jp{~[ebNX^XNnhMTXCBɊi[Ƃ̌^} */
#define _KERNEL_MTXCB_TBITDEF_MTXHDL


/* %jp{~[ebNX̏Dx^} */
typedef PRI								_KERNEL_MTX_T_CEILPRI;			/**< %jp{~[ebNX̏DxZ삷Ƃ̌^} */
typedef PRI								_KERNEL_MTXCB_T_CEILPRI;		/**< %jp{~[ebNX̏DxMTXCBɊi[Ƃ̌^} */
#define _KERNEL_MTXCB_TBITDEF_CEILPRI


/* %jp{~[ebNXp̌^} */
#if _KERNEL_MTXCB_BITFIELD		/* %jp{MTXCBɃrbgtB[h𗘗pꍇ} */

typedef unsigned int					_KERNEL_MTX_T_MTXATR;
typedef unsigned int					_KERNEL_MTXCB_T_MTXATR;
#define _KERNEL_MTXCB_TBITDEF_MTXATR	: 3

#else							/* %jp{MTXCBɃrbgtB[h𗘗pȂꍇ} */

typedef _KERNEL_T_FAST_UB				_KERNEL_MTX_T_MTXATR;
typedef _KERNEL_T_LEAST_UB				_KERNEL_MTXCB_T_MTXATR;
#define _KERNEL_MTXCB_TBITDEF_MTXATR

#endif



/* ------------------------------------------ */
/*  Control block                             */
/* ------------------------------------------ */

#if _KERNEL_MTXCB_SPLIT_RO


/** %jp{~[ebNXRg[ubN([hI[)}%en{Mutex Control Block(read-only)} */
typedef struct _kernel_t_mtxcb_ro
{
#if _KERNEL_MTXCB_MTXATR
	_KERNEL_MTXCB_T_MTXATR	mtxatr		_KERNEL_MTXCB_TBITDEF_MTXATR;		/**< %jp{~[ebNX} */
#endif

#if _KERNEL_MTXCB_CEILPRI
	_KERNEL_MTXCB_T_CEILPRI	ceilpri		KERNEL_MTXCB_TBITDEF_CEILPRI;		/**< %jp{~[ebNX̏Dx} */
#endif
} _KERNEL_T_MTXCB_RO;

typedef const _KERNEL_T_MTXCB_RO	*_KERNEL_T_MTXCB_RO_PTR;


/** %jp{~[ebNXRg[ubN}%en{Mutex Control Block} */
typedef struct _kernel_t_mtxcb
{
#if _KERNEL_MTXCB_QUE
	_KERNEL_T_QUE			que;											/**< %jp{~[ebNX҂^XNL[} */
#endif

#if _KERNEL_MTXCB_TSKHDL
	_KERNEL_MTXCB_T_TSKHDL	tskhdl		_KERNEL_MTXCB_TBITDEF_TSKHDL;		/**< %jp{~[ebNX^XÑnh} */
#endif

#if _KERNEL_MTXCB_NEXT
	_KERNEL_T_MTXHDL		next;											/**< %jp{̃~[ebNXnh} */
#endif

#if _KERNEL_MTXCB_PREV
	_KERNEL_T_MTXHDL		prev;											/**< %jp{Õ~[ebNXnh} */
#endif

#if _KERNEL_MTXCB_ALGORITHM == _KERNEL_MTXCB_ALG_PTRARRAY
	_KERNEL_T_MTXCB_RO_PTR	mtxcb_ro;										/**< %jp{~[ebNXRg[ubNROւ̃|C^} */
#endif
} _KERNEL_T_MTXCB;

typedef _KERNEL_T_MTXCB				*_KERNEL_T_MTXCB_PTR;


#else


/** %jp{~[ebNXRg[ubN}%en{Mutex Control Block} */
typedef struct _kernel_t_mtxcb
{
#if _KERNEL_MTXCB_QUE
	_KERNEL_T_QUE			que;											/**< %jp{~[ebNX҂^XNL[} */
#endif

#if _KERNEL_MTXCB_TSKHDL
	_KERNEL_MTXCB_T_TSKHDL	tskhdl		_KERNEL_MTXCB_TBITDEF_TSKHDL;		/**< %jp{~[ebNX^XÑnh} */
#endif

#if _KERNEL_MTXCB_NEXT
	_KERNEL_T_MTXHDL		next;											/**< %jp{̃~[ebNXnh} */
#endif

#if _KERNEL_MTXCB_PREV
	_KERNEL_T_MTXHDL		prev;											/**< %jp{Õ~[ebNXnh} */
#endif

#if _KERNEL_MTXCB_MTXATR
	_KERNEL_MTXCB_T_MTXATR	mtxatr		_KERNEL_MTXCB_TBITDEF_MTXATR;		/**< %jp{~[ebNX} */
#endif

#if _KERNEL_MTXCB_CEILPRI
	_KERNEL_MTXCB_T_CEILPRI	ceilpri		_KERNEL_MTXCB_TBITDEF_CEILPRI;		/**< %jp{~[ebNX̏Dx} */
#endif
} _KERNEL_T_MTXCB;

typedef _KERNEL_T_MTXCB				_KERNEL_T_MTXCB_RO;
typedef const _KERNEL_T_MTXCB_RO	*_KERNEL_T_MTXCB_RO_PTR;
typedef _KERNEL_T_MTXCB				*_KERNEL_T_MTXCB_PTR;


#endif



/* ------------------------------------------ */
/*  ID range                                  */
/* ------------------------------------------ */

extern const ID							_kernel_max_mtxid;										/**< %jp{~[ebNXID̍ől} */

#define _KERNEL_MTX_TMIN_ID				1														/**< %jp{~[ebNXID̍ŏl} */
#define _KERNEL_MTX_TMAX_ID				(_kernel_max_mtxid)										/**< %jp{~[ebNXID̍ől} */

#define _KERNEL_MTX_CHECK_MTXID(mtxid)	((mtxid) >= _KERNEL_MTX_TMIN_ID && (mtxid) <= _KERNEL_MTX_TMAX_ID)
																								/**< %jp{ID͈̓`FbN} */


/* ------------------------------------------ */
/*  Control block tables                      */
/* ------------------------------------------ */

#if _KERNEL_MTXCB_ALGORITHM == _KERNEL_MTXCB_ALG_BLKARRAY
#if _KERNEL_MTXCB_SPLIT_RO

/* %jp{ubNzǗRȌꍇ}%en{block array} */
extern  _KERNEL_T_MTXCB					_kernel_mtxcb_tbl[];									/**< %jp{~[ebNXRg[ubNe[u} */
extern const _KERNEL_T_MTXCB_RO			_kernel_mtxcb_ro_tbl[];									/**< %jp{~[ebNXRg[ubN([hI[)e[u} */
#define _KERNEL_MTX_ID2MTXCB(mtxid)		(&_kernel_mtxcb_tbl[(mtxid) - _KERNEL_MTX_TMIN_ID])		/**< %jp{Rg[ubN̎擾} */
#define _KERNEL_MTX_CHECK_EXS(mtxid)	(_kernel_mtxcb_ro_tbl[(mtxid) - _KERNEL_MTX_TMIN_ID].mtxatr != 0)
																								/**< %jp{IuWFNg̑݃`FbN} */

#else

/* %jp{ubNzǗ̏ꍇ}%en{block array} */
extern  _KERNEL_T_MTXCB					_kernel_mtxcb_tbl[];									/**< %jp{~[ebNXRg[ubNe[u} */
#define _KERNEL_MTX_ID2MTXCB(mtxid)		(&_kernel_mtxcb_tbl[(mtxid) - _KERNEL_MTX_TMIN_ID])		/**< %jp{Rg[ubN̎擾} */
#define _KERNEL_MTX_CHECK_EXS(mtxid)	(_kernel_mtxcb_tbl[(mtxid) - _KERNEL_MTX_TMIN_ID].mtxatr != 0)			
																								/**< %jp{IuWFNg̑݃`FbN} */

#endif

#elif _KERNEL_MTXCB_ALGORITHM == _KERNEL_MTXCB_ALG_PTRARRAY

/* %jp{|C^zǗ̏ꍇ}%en{pointer array} */
extern  _KERNEL_T_MTXCB					*_kernel_mtxcb_tbl[];									/**< %jp{~[ebNXRg[ubNe[u} */
#define _KERNEL_MTX_ID2MTXCB(mtxid)		(_kernel_mtxcb_tbl[(mtxid) - _KERNEL_MTX_TMIN_ID])		/**< %jp{~[ebNXIDMTXCB AhX擾} */
#define _KERNEL_MTX_CHECK_EXS(mtxid)	(_KERNEL_MTX_ID2MTXCB(mtxid) != NULL)					/**< %jp{IuWFNg̑݃`FbN} */

#endif



/* ------------------------------------------ */
/*  Convert Handle                            */
/* ------------------------------------------ */

#if _KERNEL_MTXHDL_ID		/* %jp{~[ebNXnhIDg}%en{MTXHDL is ID} */

#define _KERNEL_MTX_ID2MTXHDL(mtxid)			(mtxid)
#define _KERNEL_MTX_MTXHDL2ID(mtxhdl)			(mtxhdl)
#define _KERNEL_MTX_MTXCB2MTXHDL(mtxcb)			_KERNEL_MTX_MTXCB2ID(mtxcb)
#define _KERNEL_MTX_MTXHDL2MTXCB(mtxhdl)		_KERNEL_MTX_ID2MTXCB(mtxhdl)
#define _KERNEL_MTX_GET_MTXHDL(mtxid, mtxcb)	(mtxid)

#else						/* %jp{~[ebNXnhMTXCB̃AhXg}%en{TSKHDL is Address of MTXCB} */

#define _KERNEL_MTX_ID2MTXHDL(mtxid)			_KERNEL_MTX_ID2MTXCB(mtxid)
#define _KERNEL_MTX_MTXHDL2ID(mtxhdl)			_KERNEL_MTX_MTXCB2ID(mtxhdl)
#define _KERNEL_MTX_MTXCB2MTXHDL(mtxcb)			(mtxhdl)
#define _KERNEL_MTX_MTXHDL2MTXCB(mtxhdl)		(mtxhdl)
#define _KERNEL_MTX_GET_MTXHDL(mtxid, mtxcb)	(mtxcb)

#endif



/* ------------------------------------------ */
/*   Accessor for MTXCB                       */
/* ------------------------------------------ */

/* mtxcb_ro */
#if !_KERNEL_MTXCB_SPLIT_RO								
#define _KERNEL_MTX_GET_MTXCB_RO(mtxid, mtxcb)	(mtxcb)
#else
#if _KERNEL_MTXCB_ALGORITHM == _KERNEL_MTXCB_ALG_BLKARRAY		/* %jp{MTXCBPzŊǗ}%en{array of block} */
#define _KERNEL_MTX_GET_MTXCB_RO(mtxid, mtxcb)	(&_kernel_mtxcb_ro_tbl[(mtxid)])
#elif _KERNEL_MTXCB_ALGORITHM == _KERNEL_MTXCB_ALG_PTRARRAY		/* %jp{MTXCB|C^zŊǗ}%en{array of pointer} */
#define _KERNEL_MTX_GET_MTXCB_RO(mtxid, mtxcb)	((mtxcb)->mtxcb_ro)
#endif
#endif


/* que */
#define _KERNEL_MTX_GET_QUE(mtxcb)				(&(mtxcb)->que)


/* tskhdl */
#if _KERNEL_MTXCB_TSKHDL
#define _KERNEL_MTX_SET_TSKHDL(mtxcb, x)		do { (mtxcb)->tskhdl = (_KERNEL_MTXCB_T_TSKHDL)(x); } while (0)
#define _KERNEL_MTX_GET_TSKHDL(mtxcb)			((_KERNEL_MTX_T_TSKHDL)(mtxcb)->tskhdl)
#else
#define _KERNEL_MTX_SET_TSKHDL(mtxcb, x)		do { } while (0)
#define _KERNEL_MTX_GET_TSKHDL(mtxcb)			(0)
#endif


/* next */
#if _KERNEL_MTXCB_NEXT
#define _KERNEL_MTX_SET_NEXT(mtxcb, x)			do { (mtxcb)->next = (_KERNEL_MTXCB_T_MTXHDL)(x); } while (0)
#define _KERNEL_MTX_GET_NEXT(mtxcb)				((_KERNEL_MTX_T_MTXHDL)(mtxcb)->next)
#else
#define _KERNEL_MTX_SET_NEXT(mtxcb, x)			do { } while (0)
#define _KERNEL_MTX_GET_NEXT(mtxcb)				(0)
#endif


/* prev */
#if _KERNEL_MTXCB_PREV
#define _KERNEL_MTX_SET_PREV(mtxcb, x)			do { (mtxcb)->prev = (_KERNEL_MTXCB_T_MTXHDL)(x); } while (0)
#define _KERNEL_MTX_GET_PREV(mtxcb)				((_KERNEL_MTX_T_MTXHDL)(mtxcb)->prev)
#else
#define _KERNEL_MTX_SET_PREV(mtxcb, x)			do { } while (0)
#define _KERNEL_MTX_GET_PREV(mtxcb)				(0)
#endif



/* mtxatr */
#if _KERNEL_MTXCB_MTXATR
#define _KERNEL_MTX_SET_MTXATR(mtxcb_ro, x)		do { (mtxcb_ro)->mtxatr = (_KERNEL_MTXCB_T_MTXATR)(x); } while (0)
#define _KERNEL_MTX_GET_MTXATR(mtxcb_ro)		((_KERNEL_MTX_T_MTXATR)(mtxcb_ro)->mtxatr)
#else
#define _KERNEL_MTX_SET_MTXATR(mtxcb_ro, x)		do { } while (0)
#if _KERNEL_SPT_MTX_TA_CEILING
#define _KERNEL_MTX_GET_MTXATR(mtxcb_ro)		(TA_CEILING)
#else
#define _KERNEL_MTX_GET_MTXATR(mtxcb_ro)		(TA_INHERIT)
#endif
#endif


/* ceilpri */
#if _KERNEL_MTXCB_CEILPRI
#define _KERNEL_MTX_SET_CEILPRI(mtxcb_ro, x)	do { (mtxcb_ro)->ceilpri = (_KERNEL_MTXCB_T_CEILPRI)(x); } while (0)
#define _KERNEL_MTX_GET_CEILPRI(mtxcb_ro)		((_KERNEL_MTX_T_CEILPRI)(mtxcb_ro)->ceilpri)
#else
#define _KERNEL_MTX_SET_CEILPRI(mtxcb_ro, x)	do { } while (0)
#define _KERNEL_MTX_GET_CEILPRI(mtxcb_ro)		(1)
#endif



/* ------------------------------------------ */
/*   Macro functions                          */
/* ------------------------------------------ */

/* %jp{L[ڑ} */
#if _KERNEL_SPT_MTX_TA_TFIFO && _KERNEL_SPT_MTX_TA_TPRI		/* %jp{TA_TFIFO  TA_TPRI ̍ } */
#define _KERNEL_MTX_ADD_QUE(mtxcb, mtxcb_ro, tskhdl)	_KERNEL_ADD_QUE(_KERNEL_MTX_GET_QUE(mtxcb), tskhdl, _KERNEL_MTX_GET_MTXATR(mtxcb_ro))
#elif _KERNEL_SPT_MTX_TA_TFIFO && !_KERNEL_SPT_SE_TA_TPRI	/* %jp{TA_TFIFO ̂ݗp } */
#define _KERNEL_MTX_ADD_QUE(mtxcb, mtxcb_ro, tskhdl)	_KERNEL_ADF_QUE(_KERNEL_MTX_GET_QUE(mtxcb), tskhdl)
#elif !_KERNEL_SPT_MTX_TA_TFIFO && _KERNEL_SPT_MTX_TA_TPRI	/* %jp{TA_TPRI ̂ݗp } */
#define _KERNEL_MTX_ADD_QUE(mtxcb, mtxcb_ro, tskhdl)	_KERNEL_ADP_QUE(_KERNEL_MTX_GET_QUE(mtxcb), tskhdl)
#else
#error error:_KERNEL_SPT_MTX_TA_TPRI and _KERNEL_SPT_MTX_TA_TFIFO
#endif

/* %jp{L[O} */
#define _KERNEL_MTX_RMV_QUE(mtxcb, tskhdl)	_KERNEL_RMV_QUE(_KERNEL_MTX_GET_QUE(mtxcb), tskhdl)

/* %jp{L[擪o} */
#define _KERNEL_MTX_RMH_QUE(mtxcb)			_KERNEL_RMH_QUE(_KERNEL_MTX_GET_QUE(mtxcb))


/* %jp{^CAEgL[ڑ} */
#if _KERNEL_SPT_TLOC_MTX	/* %jp{tloc_mtxT|[g̓^CAEgL[l} */
#define _KERNEL_MTX_ADD_TOQ(tskhdl, tmout)	_KERNEL_SYS_ADD_TOQ(tskhdl, tmout)
#else
#define _KERNEL_MTX_ADD_TOQ(tskhdl)			do { } while (0)
#endif

/* %jp{^CAEgL[O} */
#if _KERNEL_SPT_TLOC_MTX	/* %jp{tloc_mtxT|[g̓^CAEgL[l} */
#define _KERNEL_MTX_RMV_TOQ(tskhdl)			_KERNEL_SYS_RMV_TOQ(tskhdl)
#else
#define _KERNEL_MTX_RMV_TOQ(tskhdl)			do { } while (0)
#endif



/* ------------------------------------------ */
/*   Functions                                */
/* ------------------------------------------ */

#ifdef __cplusplus
extern "C" {
#endif

ER   _kernel_cre_mtx(ID mtxid, const T_CMTX *pk_cmtx);					/**< %jp{~[ebNX}%en{Create Mutex} */
ER   _kernel_loc_mtx(ID mtxid, TMO tmout);								/**< %jp{~[ebNX̃bN()} */
void _kernel_add_mtx(_KERNEL_T_MTXHDL mtxhdl, _KERNEL_T_TSKHDL tskhdl);	/**< %jp{^XNɃ~[ebNXڑ} */
void _kernel_rmv_mtx(_KERNEL_T_MTXHDL mtxhdl, _KERNEL_T_TSKHDL tskhdl);	/**< %jp{^XN~[ebNXO} */


#ifdef __cplusplus
}
#endif



#endif	/* _KERNEL__object__mtxobj_h__ */


/* end of file */
